"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spread = (this && this.__spread) || function () {
    for (var ar = [], i = 0; i < arguments.length; i++) ar = ar.concat(__read(arguments[i]));
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var components_1 = require("./components");
var ReactDOM = __importStar(require("react-dom"));
var ContextMenu = /** @class */ (function () {
    function ContextMenu(options) {
        var _this = this;
        if (options === void 0) { options = {}; }
        this.options = {
            id: '',
        };
        this.menuItems = [];
        this._visible = false;
        this.onClickItem = function (menuItem, w, e) {
            var _a = menuItem.type, type = _a === void 0 ? 'normal' : _a, _b = menuItem.enabled, enabled = _b === void 0 ? true : _b, _c = menuItem.visible, visible = _c === void 0 ? true : _c;
            if (enabled) {
                if (type === 'checkbox') {
                    menuItem.checked = !menuItem.checked;
                }
            }
            // 메뉴가 클릭되었다는 것은 인지하는 곳.
            _this.visible = false;
        };
        // document.body에서 마우스 다운이 일어난 경우 contextMenu안쪽이 클릭된 것이지 바깥쪽에서 마우스 다운이 일어 난 건지 체크.
        this.onMousedownBody = function (e) {
            var _a;
            var el = e.target;
            if (el && el instanceof Node && !((_a = _this.container) === null || _a === void 0 ? void 0 : _a.contains(el))) {
                _this.visible = false;
            }
        };
        this.onKeyDownWindow = function (e) {
            if (e.which === 27) {
                _this.visible = false;
            }
        };
        this.options = options;
    }
    Object.defineProperty(ContextMenu.prototype, "visible", {
        get: function () {
            return this._visible;
        },
        set: function (tf) {
            this._visible = tf;
            this.menuItems
                .filter(function (n) { return n; })
                .forEach(function (n) {
                n.opened = false;
            });
            this.render();
        },
        enumerable: false,
        configurable: true
    });
    ContextMenu.prototype.setMenu = function (menuItems) {
        this.menuItems = __spread(menuItems);
        this.render();
        return this;
    };
    ContextMenu.prototype.popup = function (popupOption) {
        var _a = popupOption !== null && popupOption !== void 0 ? popupOption : {}, _b = _a.x, containerLeft = _b === void 0 ? 0 : _b, _c = _a.y, containerTop = _c === void 0 ? 0 : _c;
        var _d = this.options.id, id = _d === void 0 ? '' : _d;
        var existContainer = document.querySelectorAll("[data-rewm-contextmenu-container=\"" + id + "\"]")[0];
        if (existContainer && id !== '') {
            this.container = existContainer;
            document.body.appendChild(this.container);
        }
        else {
            this.container = document.createElement('div');
            this.container.setAttribute('data-rewm-contextmenu-container', id);
            document.body.appendChild(this.container);
        }
        // set style of this.container
        this.container.style.position = 'absolute';
        this.container.style.left = containerLeft + 'px';
        this.container.style.top = containerTop + 'px';
        if (this.container) {
            this.visible = true;
        }
    };
    ContextMenu.prototype.close = function () {
        this.visible = false;
    };
    ContextMenu.prototype.render = function () {
        if (!this.container) {
            return;
        }
        var _a = this.options.style, style = _a === void 0 ? {} : _a;
        ReactDOM.render(React.createElement(components_1.PopupMenu, { menuItems: this.menuItems, onClickItem: this.onClickItem, visible: this.visible, parentOffset: {
                top: this.container.offsetTop,
                left: this.container.offsetLeft,
            }, userStyle: __assign(__assign({}, style), { left: 0, top: 0 }) }), this.container);
        if (this.visible) {
            document.body.addEventListener('mousedown', this.onMousedownBody);
            window.addEventListener('keydown', this.onKeyDownWindow);
        }
        else {
            document.body.removeEventListener('mousedown', this.onMousedownBody);
            window.removeEventListener('keydown', this.onKeyDownWindow);
        }
    };
    return ContextMenu;
}());
exports.default = ContextMenu;
