"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var ContextMenu_1 = __importDefault(require("./ContextMenu"));
var getMenuLabelName_1 = __importDefault(require("./common/getMenuLabelName"));
var MenuBar = /** @class */ (function (_super) {
    __extends(MenuBar, _super);
    function MenuBar(props) {
        var _this = _super.call(this, props) || this;
        _this.onMousedownBody = function (ev) {
            var el = ev.target;
            if (_this.containerRef.current) {
                if (el && el instanceof Node && !_this.containerRef.current.contains(el)) {
                    _this.setState({ active: false, openedMenuIndex: -1 });
                    document.body.removeEventListener('mousedown', _this.onMousedownBody);
                    window.removeEventListener('keydown', _this.onKeyDownWindow);
                }
            }
        };
        _this.onKeyDownWindow = function (ev) {
            var altKey = ev.altKey, shiftKey = ev.shiftKey, ctrlKey = ev.ctrlKey, metaKey = ev.metaKey, which = ev.which;
            _this.keydownInfo = [shiftKey, ctrlKey, metaKey, which].join('-');
        };
        _this.onKeyUpWindow = function (ev) {
            // const { altKey, shiftKey, ctrlKey, metaKey, which } = ev;
            // const keyupInfo = [shiftKey, ctrlKey, metaKey, which].join('-');
            // console.log(this.keydownInfo, keyupInfo, this.keydownInfo === keyupInfo);
        };
        _this.handleMenuBarActive = function () {
            _this.setState({
                active: true,
            });
            document.body.addEventListener('mousedown', _this.onMousedownBody);
        };
        _this.handleMenuClick = function (e, menuIndex) {
            _this.handleSubmenuPopup(e, menuIndex);
        };
        _this.handleMenuOver = function (e, menuIndex) {
            var active = _this.state.active;
            if (!active) {
                return;
            }
            _this.handleSubmenuPopup(e, menuIndex);
        };
        _this.handleSubmenuPopup = function (e, menuIndex) {
            var _a = _this.props.items, items = _a === void 0 ? [] : _a;
            var item = items[menuIndex];
            var submenu = _this.childMenu[menuIndex];
            if (!submenu || !item) {
                return;
            }
            if (!e.currentTarget) {
                return;
            }
            if (!_this.containerRef.current) {
                return;
            }
            var _b = _this.state.openedMenuIndex, openedMenuIndex = _b === void 0 ? -1 : _b;
            var pageXOffset = window.pageXOffset, pageYOffset = window.pageYOffset;
            var _c = e.currentTarget.getBoundingClientRect(), left = _c.left, top = _c.top, height = _c.height;
            if (openedMenuIndex !== menuIndex) {
                _this.childMenu[openedMenuIndex] &&
                    _this.childMenu[openedMenuIndex].close();
            }
            // submenu.setMenu(item.submenu || []);
            submenu.popup({ x: left + pageXOffset, y: top + height + pageYOffset });
            _this.setState({
                openedMenuIndex: menuIndex,
            });
        };
        _this.initSubmenu = function () {
            var _a = _this.props, _b = _a.items, items = _b === void 0 ? [] : _b, _c = _a.submenu, _d = _c === void 0 ? {} : _c, _e = _d.style, _submenuStyle = _e === void 0 ? {} : _e, _f = _d.placement, placement = _f === void 0 ? 'bottom' : _f;
            var submenuStyle = __assign({}, _submenuStyle);
            if (placement === 'bottom') {
                submenuStyle.borderTopLeftRadius = 0;
                submenuStyle.borderTopRightRadius = 0;
                submenuStyle.marginTop = 0;
            }
            _this.childMenu = [];
            items.forEach(function (menu, i) {
                var submenu = new ContextMenu_1.default({
                    id: "menu-" + i,
                    style: submenuStyle,
                    placement: placement,
                });
                submenu.setMenu(menu.submenu || []);
                _this.childMenu.push(submenu);
            });
        };
        _this.childMenu = [];
        _this.containerRef = React.createRef();
        _this.state = {
            active: false,
            altKeyPressed: false,
            openedMenuIndex: -1,
        };
        return _this;
    }
    MenuBar.prototype.componentDidMount = function () {
        var enableAltKeyAction = this.props.enableAltKeyAction;
        this.initSubmenu();
        if (enableAltKeyAction) {
            window.addEventListener('keydown', this.onKeyDownWindow, false);
            window.addEventListener('keyup', this.onKeyUpWindow, false);
        }
    };
    MenuBar.prototype.componentDidUpdate = function (prevProps) {
        if (prevProps.items !== this.props.items) {
            this.initSubmenu();
        }
    };
    MenuBar.prototype.componentWillUnmount = function () {
        var enableAltKeyAction = this.props.enableAltKeyAction;
        if (enableAltKeyAction) {
            window.removeEventListener('keydown', this.onKeyDownWindow);
            window.removeEventListener('keyup', this.onKeyUpWindow);
        }
    };
    MenuBar.prototype.render = function () {
        var _this = this;
        var _a = this.state, active = _a.active, altKeyPressed = _a.altKeyPressed, openedMenuIndex = _a.openedMenuIndex;
        var _b = this.props, _c = _b.items, items = _c === void 0 ? [] : _c, style = _b.style;
        var menuBarStyle = __assign({}, style);
        return (React.createElement("div", { ref: this.containerRef, className: "rewm-menubar" + (active ? ' rewm-menubar-active' : ''), style: menuBarStyle }, items.map(function (menu, mi) {
            return (React.createElement("div", { className: "" + (openedMenuIndex === mi ? 'active' : ''), key: mi, "data-menubar-item": true, onMouseDown: function () {
                    _this.handleMenuBarActive();
                }, onClick: function (e) {
                    _this.handleMenuClick(e, mi);
                }, onMouseOver: function (e) {
                    _this.handleMenuOver(e, mi);
                } }, getMenuLabelName_1.default(menu.label, altKeyPressed)));
        })));
    };
    return MenuBar;
}(React.Component));
exports.default = MenuBar;
