"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const React = __importStar(require("react"));
const components_1 = require("./components");
const ReactDOM = __importStar(require("react-dom"));
class ContextMenu {
    constructor(options = {}) {
        this.options = {
            id: '',
        };
        this.menuItems = [];
        this._visible = false;
        this.onClickItem = (menuItem, w, e) => {
            const { type = 'normal', enabled = true, visible = true } = menuItem;
            if (enabled) {
                if (type === 'checkbox') {
                    menuItem.checked = !menuItem.checked;
                }
            }
            // 메뉴가 클릭되었다는 것은 인지하는 곳.
            this.visible = false;
        };
        // document.body에서 마우스 다운이 일어난 경우 contextMenu안쪽이 클릭된 것이지 바깥쪽에서 마우스 다운이 일어 난 건지 체크.
        this.onMousedownBody = (e) => {
            var _a;
            var el = e.target;
            if (el && el instanceof Node && !((_a = this.container) === null || _a === void 0 ? void 0 : _a.contains(el))) {
                this.visible = false;
            }
        };
        this.onKeyDownWindow = (e) => {
            if (e.which === 27) {
                this.visible = false;
            }
        };
        this.options = options;
    }
    get visible() {
        return this._visible;
    }
    set visible(tf) {
        this._visible = tf;
        this.menuItems
            .filter(n => n)
            .forEach(n => {
            n.opened = false;
        });
        this.render();
    }
    setMenu(menuItems) {
        this.menuItems = [...menuItems];
        this.render();
        return this;
    }
    popup(popupOption) {
        const { x: containerLeft = 0, y: containerTop = 0 } = popupOption !== null && popupOption !== void 0 ? popupOption : {};
        const { id = '' } = this.options;
        const existContainer = document.querySelectorAll(`[data-rewm-contextmenu-container="${id}"]`)[0];
        if (existContainer && id !== '') {
            this.container = existContainer;
            document.body.appendChild(this.container);
        }
        else {
            this.container = document.createElement('div');
            this.container.setAttribute('data-rewm-contextmenu-container', id);
            document.body.appendChild(this.container);
        }
        // set style of this.container
        this.container.style.position = 'absolute';
        this.container.style.left = containerLeft + 'px';
        this.container.style.top = containerTop + 'px';
        if (this.container) {
            this.visible = true;
        }
    }
    close() {
        this.visible = false;
    }
    render() {
        if (!this.container) {
            return;
        }
        const { style = {} } = this.options;
        ReactDOM.render(React.createElement(components_1.PopupMenu, { menuItems: this.menuItems, onClickItem: this.onClickItem, visible: this.visible, parentOffset: {
                top: this.container.offsetTop,
                left: this.container.offsetLeft,
            }, userStyle: Object.assign(Object.assign({}, style), { left: 0, top: 0 }) }), this.container);
        if (this.visible) {
            document.body.addEventListener('mousedown', this.onMousedownBody);
            window.addEventListener('keydown', this.onKeyDownWindow);
        }
        else {
            document.body.removeEventListener('mousedown', this.onMousedownBody);
            window.removeEventListener('keydown', this.onKeyDownWindow);
        }
    }
}
exports.default = ContextMenu;
